//
//  Copyright (C) 1997,1998,1999 Forest Edge Software, All Rights Reserved
//
//  Program:    eVAX, a "Virtual VAX" for Mac OS Computers
//
//  Author:     Tom Cole
//
//  Module:     vaxproto.h
//
//  Purpose:    This module prototype definitions for shared routines
//              in the emulator _other_ than the assembler or the
//              instruction emulators.  Included from vax.pch.
//
//  History:    02/23/98    Unified header
//
//



//  Public prototypes

long execute_vax( struct VAX * vax, short disasm );
long execute_symbol( struct VAX * vax, char * symbol, short disasm );
long decode_instruction( struct VAX * vax, struct OPCODE * opcode, short disasm );
long dump_registers( struct VAX * vax );
long dump_psl( struct VAX * vax );
long exam_reg( struct VAX * vax, long verb );
long set_reg( struct VAX * vax, char ** P );
long format_instruction( struct VAX * vax, unsigned long addr );
void pad( char * buff, int len );

long show_regions( struct VAX * vax );

long assemble( struct VAX ** vax, char ** buffer );
long probe( struct VAX * vax, unsigned long addr, short size, short mode );
long uppercase( char * p );
long read_verb( struct VAX * vax, char ** P, long * code );

long help( struct VAX ** Vax, char ** P );
long console( struct VAX ** vax, char * cmd );

long decode_operand( struct VAX * vax,          /* The virtual machine state    */
                    struct OPCODE * opcode,     /* The opcode structure         */
                    short opcount,              /* Which operand are we doing?  */
                    long * the_pc,              /* Virtual PC address           */
                    short *Treg,                /* Index of temp regs           */
                    short scale,                /* Scale of operand             */
                    short idx,                  /* Are we in indexed mode       */
                    char * disasm );            /* Disasm buffer if any         */
                    
long alloc_vax( struct VAX ** theVax, long physmem );
long free_vax( struct VAX ** theVax );
long init_emulators( struct VAX * vax );

long read_psl_bits( struct VAX * vax );
long write_psl_bits( struct VAX * vax );

long handle_fault( struct VAX * vax  );
long set_fault( struct VAX * vax, long code, long count, ... );
long interrupt( struct VAX * vax, long code, long ipl, long quantum );

long load_memory( struct VAX * vax, long addr, unsigned char * dest, short count);
long load_byte( struct VAX * vax, long address, unsigned char * dest );
long load_register( struct VAX * vax, short regn, unsigned long address, short count);

long push_data( struct VAX * vax, void * data, short len );
long store_memory( struct VAX * vax, long addr, unsigned char * src, short count);
long sext( long data, short size );
long vm( struct VAX * vax, unsigned long * Addr, short * size, short mode );
void invalidate_tb();
void invalidate_tb_prot();
void invalidate_page( unsigned long addr );
long set_priv_reg( struct VAX * vax, short reg, long value );
void set_mode_stack( struct VAX * vax, long newmode );
char * get_operand( struct VAX * vax, struct OPCODE * opcode, short n, short mode );
long put_operand( struct VAX * vax,
                  struct OPCODE * opcode,
                  short n,
                  short mode,
                  char * data );

long get_memory_field( struct VAX * vax, long position, long size, long base, long * result_p );
long get_register_field( struct VAX * vax, long position, long size, long base, long * result_p );

long set_memory_field( struct VAX * vax, long position, long size, long base, long data );
long set_register_field( struct VAX * vax, long position, long size, long base, long data );
unsigned long bit_sext( unsigned long data, long size );

char * vaxmsg( long rc );
char * vaxexcept( short code );

char * format_mask( unsigned short mask );

long flush_blanks( char ** P );
long uppercase( char * p );

int   is_blank( char ch );

void freemem( void * p );
char * getmem( long size );
void printmem( void );


short   isend( struct VAX * vax, char ch );

/*
 *  This is a Mac function, lets simulate it for other hosts.  It
 *  should be defined in DRIVER.C
 */

#ifndef macintosh
long TickCount( void );
#endif


#include "emulator_entries.h"


