//
//  Copyright (C) 1997,1998,1999 Forest Edge Software, All Rights Reserved
//
//  Program:    eVAX, a "Virtual VAX" for Mac OS Computers
//
//  Author:     Tom Cole
//
//  Module:     asm_opcode.c
//
//  Purpose:    Pseudoassembler for the console interface to the VAX.
//
//
//  History:    02/01/98    Initially created from asm.c
//
//              09/24/98    Signal error if attempting to assemble opcode that
//                          has no implemented routine address.
//


#include "vax.pch"
#include "vaxinstr.h"

//  Local prototypes

#include "asmproto.h"




//  From current position, find the opcode and remove it.

long asm_opcode( struct VAX * vax, char ** Buffptr, long * count )
{

    char    b[ 16 ], ch;
    long    n, j;
    char    * p;
    long    rc;
    
//  Skip spaces
    p = *Buffptr;
    
    flush_blanks( &p );
    
    if( isend( vax, *p ))
        return VAX_ASMNOOPCODE;
    
    n = 0;

//  Copy until end of opcode

    while( !is_blank( *p ) && !isend( vax, *p )) {
    
        ch = *(p++);
        b[ n++ ] = ch;
        
    }
    b[ n ] = 0;
    
//  Save where we scanned to

    *Buffptr = p;

//  Search the instruction array looking for a matching name

    for( j = 0; instruction[ j ].name[ 0 ]; j++ ) {
    
        if( strcmp( instruction[ j ].name, b ) == 0 ) {

            if( instruction[ j ].extended ) {
                rc = store_memory( vax, vax-> console.deposit++, ( void * ) &(instruction[ j ].extended ), 1 );
                if( rc )
                    return rc;
            }

            rc = store_memory( vax, vax-> console.deposit++, ( void * ) &(instruction[ j ].opcode ), 1 );
            if( rc )
                return rc;
            
            vax-> console.scale = instruction[ j ].scale;

            vax-> assembler.index = j;
            vax-> assembler.opcount = 0;
            vax-> assembler.scale = instruction[ j ].scale[ 0 ];
            
            *count = instruction[ j ].operand_count;
            
            if( instruction[ j ].routine == 0L )
                return VAX_ASMNOTIMP;
                
            return VAX_OK;
        }
    }
    
    return VAX_ASMINVOPCODE;
}


    
