
//
//	CONSOLE_INIT
//
//	The INIT console command creates a new virtual VAX.
//
//	Syntax:
//
//		INIT	memsize
//
//	Parameters:
//
//		memsize			The size in pages of the physical memory to create.
//

#include "vax.pch"
#include "console_proto.h"
#include "asmproto.h"

long console_init( struct VAX ** Vax, char ** P )
{
	long saved_radix, saved_disasm, saved_verify, rc;
	unsigned long value;
	struct VAX * vax;
	char * p;
	
	vax = *Vax;
	p = *P;
	

	rc = asm_hex( vax, &p, &value );
	if( rc ) {
		*P = p;
		return rc;
	}
		
	value = value * 512;

	if( vax != 0L ) {
	
		saved_radix = vax-> console.radix;
		saved_disasm = vax-> console.disasm;
		saved_verify = vax-> console.verify;
	}
	else {
		saved_radix = 16;
		saved_disasm = 0;
		saved_verify = 0;
	}
	
	free_vax( &vax );
	rc = alloc_vax( &vax, value );
	if( rc ) {
		*Vax = vax;
		return rc;
	}

	vax-> console.radix = saved_radix;
	vax-> console.disasm = saved_disasm;
	vax-> console.verify = saved_verify;
	
	/* This zeros memory AND will also clear all non-permanent symbols */

	rc = console_zero( &vax, &p );

	*Vax = vax;
	*P = p;
	return rc;
}
