//
//  Module:     librtl.c
//
//  Purpose:    This module contains the code for runtime libraries.
//				
//
//  History:    07/14/99    Initially created.
//


#include "vax.pch"
#include "vaxinstr.h"
#include "asmproto.h"       // for get_symbol()
#include "memmap.h"  		// to instantiate memory map list headers (uses GLOBAL)
#include "shim.h"


long lib_adawi( struct VAX * vax, long sum_addr, long base_addr, long sign_addr )
{

	long sum, base, sign, rc;
	
	rc = load_memory( vax, sum_addr, ( void * ) &sum, 4 );
	if( rc )
		return rc;

	rc = load_memory( vax, base_addr, ( void * ) &base, 4 );
	if( rc )
		return rc;

	base = base + sum;
	if( base < 0 )
		sign = -1;
	else
	if( base == 0 )
		sign = 0;
	else
		sign = 1;
	
	rc = store_memory( vax, sign_addr, ( void * ) &sign, 4 );
	if( rc )
		return rc;

	vax-> R0 = VAX_OK;
	return VAX_OK;

}


long str_upcase( struct VAX * vax, long dst_addr, long src_addr )
{

	return VAX_OK;
}
